package com.proyecto.libroinmersiones;

import java.text.DateFormat;
import java.util.Date;

import android.content.Context;
import android.database.Cursor;
import android.graphics.Color;
import android.graphics.PorterDuff;
import android.graphics.drawable.LayerDrawable;
import android.support.v4.widget.CursorAdapter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.RatingBar;
import android.widget.TextView;

public class AdaptadorCursorInmersiones extends CursorAdapter {
	private LayoutInflater inflador;
	TextView nombre, direccion, distancia, situacion, fecha, hora, comentario;
	ImageView foto;
	RatingBar valoracion;

	public AdaptadorCursorInmersiones(Context contexto, Cursor c) {
		super(contexto, c, false);
	}

	@Override
	public View newView(Context contexto, Cursor c, ViewGroup padre) {
		inflador = (LayoutInflater) contexto
				.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		View vista = inflador.inflate(R.layout.elemento_lista, padre, false);
		return vista;
	}

	@Override
	public void bindView(View vista, Context contexto, Cursor c) {
		nombre = (TextView) vista.findViewById(R.id.nombre);
		situacion = (TextView) vista.findViewById(R.id.situacion);
		fecha = (TextView) vista.findViewById(R.id.fecha);
		hora = (TextView) vista.findViewById(R.id.hora);
		// tipoTraje = (TextView) vista.findViewById(R.id.tipo_traje);
		foto = (ImageView) vista.findViewById(R.id.foto);
		comentario = (TextView) vista.findViewById(R.id.comentario);
		valoracion = (RatingBar) vista.findViewById(R.id.valoracion);
		nombre.setText(c.getString(c.getColumnIndex("nombre")));
		// fecha.setText(DateFormat.getDateInstance().format(new
		// Date(c.getLong(c.getColumnIndex("fecha")))));
		fecha.setText(DateFormat.getDateTimeInstance(DateFormat.SHORT,
				DateFormat.SHORT).format(
				new Date(c.getLong(c.getColumnIndex("fecha")))));
		GeoPunto coord = new GeoPunto(c.getDouble(c.getColumnIndex("longitud")),
				c.getDouble(c.getColumnIndex("latitud")));
		situacion.setText(coord.toString());
/*
		situacion.setText("Longitud: "
				+ c.getString(c.getColumnIndex("longitud")) + " Latitud: "
				+ c.getString(c.getColumnIndex("latitud")));
*/
		if (c.getString(c.getColumnIndex("comentario")) == "") {
			vista.findViewById(R.id.logo_comentario).setVisibility(View.GONE);
			vista.findViewById(R.id.comentario).setVisibility(View.GONE);
		} else {
			comentario.setText(c.getString(c.getColumnIndex("comentario")));
		}
		// tipoTraje = c.getString(c.getColumnIndex("tipoTraje"));
		// foto.setImageResource(TipoInmersion.values()[tipo].getRecurso());
		// foto.setScaleType(ImageView.ScaleType.FIT_END);

		LayerDrawable stars = (LayerDrawable) valoracion.getProgressDrawable();
		stars.getDrawable(0).setColorFilter(Color.TRANSPARENT,
				PorterDuff.Mode.SRC_ATOP);
		stars.getDrawable(1).setColorFilter(Color.TRANSPARENT,
				PorterDuff.Mode.SRC_ATOP);
		stars.getDrawable(2).setColorFilter(Color.YELLOW,
				PorterDuff.Mode.SRC_ATOP);
		valoracion.setRating(c.getFloat(c.getColumnIndex("valoracion")));
		distancia = (TextView) vista.findViewById(R.id.distancia);
		GeoPunto posicion = new GeoPunto(c.getDouble(c
				.getColumnIndex("longitud")), c.getDouble(c
				.getColumnIndex("latitud")));
		if (Inmersiones.posicionActual != null && posicion != null
				&& posicion.getLatitud() != 0) {
			int d = (int) Inmersiones.posicionActual.distancia(posicion);
			if (d < 2000) {
				distancia.setText(d + " m");
			} else {
				distancia.setText(d / 1000 + "Km");
			}
		}
	}
}
