package com.proyecto.libroinmersiones;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;

public class CentrosBuceo {

	final static String TAG = "MisCentrosBuceo";
	protected static GeoPunto posicionActual = new GeoPunto(0, 0);
	private static InmersionesBD inmersionesBD;

	public static CentroBuceo elemento(int id) {
		CentroBuceo centroBuceo = null;
		SQLiteDatabase bd = inmersionesBD.getReadableDatabase();
		Cursor cursor = bd.rawQuery("SELECT * FROM centrosBuceo WHERE _id = "
				+ id , null);
		if (cursor.moveToNext()) {
			centroBuceo = new CentroBuceo();
			centroBuceo.setNombre(cursor.getString(1));
			centroBuceo.setDireccion(cursor.getString(2));
			centroBuceo.setPosicion(new GeoPunto(cursor.getDouble(3), cursor
					.getDouble(4)));
			centroBuceo.setTipo(TipoCentroBuceo.values()[cursor.getInt(5)]);
			centroBuceo.setFoto(cursor.getString(6));
			centroBuceo.setTelefono(cursor.getInt(7));
			centroBuceo.setUrl(cursor.getString(8));
			centroBuceo.setComentario(cursor.getString(9));
			centroBuceo.setFecha(cursor.getLong(10));
			centroBuceo.setValoracion(cursor.getFloat(11));
		}
		cursor.close();
		bd.close();
		return centroBuceo;
	}

	public static int nuevo() {
		int id = -1;
		CentroBuceo centroBuceo = new CentroBuceo();
		SQLiteDatabase bd = inmersionesBD.getWritableDatabase();
		bd.execSQL("INSERT INTO centrosBuceo (longitud, latitud, tipo, fecha) "
				+ "VALUES ( " + centroBuceo.getPosicion().getLongitud() + ","
				+ centroBuceo.getPosicion().getLatitud() + ", "
				+ centroBuceo.getTipo().ordinal() + ", " + centroBuceo.getFecha()
				+ ")");
		Cursor c = bd.rawQuery("SELECT _id FROM centrosBuceo WHERE fecha = "
				+ centroBuceo.getFecha(), null);
		if (c.moveToNext()) {
			id = c.getInt(0);
		}
		c.close();
		bd.close();
		return id;
	}

	public static void borrar(int id) {
		SQLiteDatabase bd = inmersionesBD.getWritableDatabase();
		bd.execSQL("DELETE FROM centrosBuceo WHERE _id = " + id);
		bd.close();
	}

	public static void inicializaBD(Context contexto) {
		inmersionesBD = new InmersionesBD(contexto);
	}

	public static Cursor listado() {
		SQLiteDatabase bd = inmersionesBD.getReadableDatabase();
		return bd.rawQuery(
				"SELECT * FROM centrosBuceo  WHERE tipo <> 0 ORDER BY tipo DESC LIMIT 50", null);
	}
	
	public static Cursor listadoPuntosInmersion() {
		SQLiteDatabase bd = inmersionesBD.getReadableDatabase();
		return bd.rawQuery(
				"SELECT * FROM centrosBuceo  WHERE tipo = 0 ORDER BY nombre DESC LIMIT 50", null);
	}
	public static  String[] getPuntosInmersion() {
		SQLiteDatabase bd = inmersionesBD.getReadableDatabase();
		Cursor c = bd.rawQuery(
				"SELECT  nombre FROM centrosBuceo WHERE tipo = 0 ORDER BY nombre DESC LIMIT 50", null);
		String[] resultado = new String[c.getCount()];
		Log.d("Puntos de inmersion", Integer.toString(c.getCount()));
		while (c.moveToNext()) {
			Log.d("Posicion ---->", Integer.toString(c.getPosition()));
			resultado[c.getPosition()] = c.getString(0);
		}
		c.close();
		bd.close();
		return resultado;
		
		
	}
	public static void actualizaCentroBuceo(int id, CentroBuceo centroBuceo) {
		SQLiteDatabase bd = inmersionesBD.getWritableDatabase();
		bd.execSQL("UPDATE centrosBuceo SET nombre = '" + centroBuceo.getNombre()
				+ "', direccion = '" + centroBuceo.getDireccion()
				+ "', longitud = " + centroBuceo.getPosicion().getLongitud()
				+ " , latitud = " + centroBuceo.getPosicion().getLatitud()
				+ " , tipo = " + centroBuceo.getTipo().ordinal() + " , foto = '"
				+ centroBuceo.getFoto() + "', telefono = "
				+ centroBuceo.getTelefono() + " , url = '" + centroBuceo.getUrl()
				+ "', comentario = '" + centroBuceo.getComentario()
				+ "', fecha = " + centroBuceo.getFecha() + " , valoracion = "
				+ centroBuceo.getValoracion() + " WHERE _id = " + id);
		bd.close();
	}

	public static int buscarNombre(String nombre) {
		int id = -1;
		SQLiteDatabase bd = inmersionesBD.getReadableDatabase();
		Cursor c = bd.rawQuery("SELECT * FROM centrosBuceo WHERE nombre = '"
				+ nombre + "'", null);
		if (c.moveToNext()) {
			id = c.getInt(0);
		}
		c.close();
		bd.close();
		return id;
	}
	public static GeoPunto buscarLongLat(String nombre) {
		GeoPunto coord = new GeoPunto (39.0,0.0);
		SQLiteDatabase bd = inmersionesBD.getReadableDatabase();
		Cursor c = bd.rawQuery("SELECT longitud, latitud FROM centrosBuceo WHERE nombre = '"
				+ nombre + "'", null);
		if (c.moveToNext()) {
			coord.setLatitud(c.getFloat(1));
			coord.setLongitud(c.getFloat(0));
		}
		c.close();
		bd.close();
		return coord;
	}
}
