package com.proyecto.libroinmersiones;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class DiveLog extends Activity {
	
	private Context c;
	private SharedPreferences pref;
	
	private Button bAcercaDe;
	private Button bConfiguracion;
	private Button bDives;
	private Button bSalir;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

	      //comprobamos  la conexin a internet
        if (!isOnline()){
	         
	        	Toast.makeText(this,"Internet no activado ", Toast.LENGTH_LONG).show();
	        	
        }
        
		
		bDives = (Button) findViewById(R.id.Button01);
		bDives.setOnClickListener(new OnClickListener() {
			public void onClick(View view) {
				lanzarBuceos(null);
			}
		});
		
		bConfiguracion = (Button) findViewById(R.id.Button02);
		bConfiguracion.setOnClickListener(new OnClickListener() {
			public void onClick(View view) {
				lanzarPuntosInmersion(null);
			}
		});
		
		bAcercaDe = (Button) findViewById(R.id.Button03);
		bAcercaDe.setOnClickListener(new OnClickListener() {
			public void onClick(View view) {
				lanzarAcercaDe(null);
			}
		});
		
		bSalir = (Button) findViewById(R.id.Button04);
		bSalir.setOnClickListener(new OnClickListener() {
			public void onClick(View view) {
				lanzarCentrosBuceo(null);
			}
		});
	}

	
	public void lanzarBuceos(View view) {
		 Intent i = new Intent(this, ListaInmersiones.class);
		 startActivity(i);
	}
	public void lanzarPuntosInmersion(View view) {
		 Intent i = new Intent(this, ListaCentrosBuceo.class);
		 i.putExtra("tipo_centro", 0);
		 startActivity(i);
	}
	
	public void lanzarCentrosBuceo(View view) {
		 Intent i = new Intent(this, ListaCentrosBuceo.class);
		 i.putExtra("tipo_centro", 1);
		 startActivity(i);
	}
	
	public void mostrarPreferencias(View view) {
		// Intent i = new Intent(this, Juego.class);
		// startActivityForResult(i, 1234);
	}
	public void lanzarAcercaDe(View view) {

		Intent i = new Intent(this, AcercaDe.class);
	//	i.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		startActivity(i);

	}
	
	//codigo para lanzar menu
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
	@Override public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
        case R.id.about:
        	 Intent acerca = new Intent(this, AcercaDe.class);
        	 startActivity(acerca);
             break;
 /*   case R.id.menu_mapa:
       	 Intent i = new Intent(this, Mapa.class);
       	 i.putExtra("tipo_mapa", 1);
       	 startActivity(i);
            break;      
      case R.id.config:
            Intent i = new Intent(this, Preferencias.class);
            startActivity(i);
            break; */
        }
        return true; 
	}
	
	
	 //funcion que nos indica si tenemos o no conexion a internet
	 public boolean isOnline() {
			ConnectivityManager cm = (ConnectivityManager) this.getSystemService(Context.CONNECTIVITY_SERVICE);

			NetworkInfo netInfo = cm.getActiveNetworkInfo();

			if (netInfo != null && netInfo.isConnectedOrConnecting()) {
			return true;
			}

			return false;
			}  
}
