package com.proyecto.libroinmersiones;

import java.io.File;
import java.text.DateFormat;
import java.util.Date;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.RatingBar;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.RatingBar.OnRatingBarChangeListener;

public class EdicionCentroBuceo extends Activity {
	private long id;
	private int tipo_centro;
	private CentroBuceo centroBuceo;
	private EditText nombre;
	private Spinner tipo;
	private EditText direccion;
	private EditText telefono;
	private EditText url;
	private EditText comentario;
	private ImageView imageView;
	private Uri uriFoto;
	final static int RESULTADO_EDITAR = 1;
	final static int RESULTADO_GALERIA = 2;
	final static int RESULTADO_FOTO = 3;

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.edicion_centro_buceo);

		Bundle extras = getIntent().getExtras();
		tipo_centro = extras.getInt("tipo_centro", 1);
		id = extras.getLong("id", -1);
		centroBuceo = CentrosBuceo.elemento((int) id);
		nombre = (EditText) findViewById(R.id.nombre);

		nombre.setText(centroBuceo.getNombre());

		ImageView logo_tipo = (ImageView) findViewById(R.id.logo_tipo);
		logo_tipo.setImageResource(centroBuceo.getTipo().getRecurso());

		tipo = (Spinner) findViewById(R.id.tipo);
		if (tipo_centro == 0) {
			String[] strSitio;
			
			ArrayAdapter<String> adaptador = new ArrayAdapter<String>(this,
					android.R.layout.simple_spinner_item,
					TipoCentroBuceo.getSitio());
			adaptador
					.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
			tipo.setAdapter(adaptador);
			tipo.setSelection(0);
		} else {

			ArrayAdapter<String> adaptador = new ArrayAdapter<String>(this,
					android.R.layout.simple_spinner_item,
					TipoCentroBuceo.getNombres());
			adaptador
					.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
			tipo.setAdapter(adaptador);
			tipo.setSelection(centroBuceo.getTipo().ordinal());
		}

		direccion = (EditText) findViewById(R.id.direccion);
		direccion.setText(centroBuceo.getDireccion());

		telefono = (EditText) findViewById(R.id.telefono);
		telefono.setText(Integer.toString(centroBuceo.getTelefono()));

		url = (EditText) findViewById(R.id.url);
		url.setText(centroBuceo.getUrl());

		comentario = (EditText) findViewById(R.id.comentario);

		comentario.setText(centroBuceo.getComentario());

		TextView fecha = (TextView) findViewById(R.id.fecha);
		fecha.setText(DateFormat.getDateInstance().format(
				new Date(centroBuceo.getFecha())));
		TextView hora = (TextView) findViewById(R.id.hora);
		hora.setText(DateFormat.getTimeInstance().format(
				new Date(centroBuceo.getFecha())));
		RatingBar valoracion = (RatingBar) findViewById(R.id.valoracion);
		valoracion.setRating(centroBuceo.getValoracion());
		valoracion
				.setOnRatingBarChangeListener(new OnRatingBarChangeListener() {
					@Override
					public void onRatingChanged(RatingBar ratingBar,
							float valor, boolean fromUser) {
						centroBuceo.setValoracion(valor);
					}
				});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.edicion_inmersion, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.accion_guardar:
			centroBuceo.setNombre(nombre.getText().toString());
			centroBuceo.setTipo(TipoCentroBuceo.values()[tipo
					.getSelectedItemPosition()]);
			centroBuceo.setDireccion(direccion.getText().toString());
			centroBuceo.setTelefono(Integer.parseInt(telefono.getText()
					.toString()));
			centroBuceo.setUrl(url.getText().toString());
			centroBuceo.setComentario(comentario.getText().toString());
			CentrosBuceo.actualizaCentroBuceo((int) id, centroBuceo);
			finish();
			return true;
		case R.id.accion_cancelar:
			 finish(); 
	          return true;
		default:
			return super.onOptionsItemSelected(item);
		}
	}
	// ************* tomarFoto *****************************************//

	public void tomarFoto(View view) {
		Intent intent = new Intent("android.media.action.IMAGE_CAPTURE");
		uriFoto = Uri.fromFile(new File(Environment
				.getExternalStorageDirectory()
				+ File.separator
				+ "img_"
				+ (System.currentTimeMillis() / 1000) + ".jpg"));
		intent.putExtra(MediaStore.EXTRA_OUTPUT, uriFoto);
		startActivityForResult(intent, RESULTADO_FOTO);
	}
	protected void ponerFoto(ImageView imageView, String uri) {
		if (uri != null) {
			imageView.setImageURI(Uri.parse(uri));
		} else {
			imageView.setImageBitmap(null);
		}
	}

	public void galeria(View view) {
		Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
		intent.addCategory(Intent.CATEGORY_OPENABLE);
		intent.setType("image/*");
		startActivityForResult(intent, RESULTADO_GALERIA);
	}

	public void eliminarFoto(View view) {
		centroBuceo.setFoto(null);
		ponerFoto(imageView, null);
		CentrosBuceo.actualizaCentroBuceo((int) id, centroBuceo);
	}
}
