package com.proyecto.libroinmersiones;

import java.io.File;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.DatePickerDialog;
import android.app.TimePickerDialog;
import android.content.Intent;
import android.content.res.Resources;
import android.graphics.Color;
import android.graphics.PorterDuff;
import android.graphics.drawable.LayerDrawable;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.RatingBar;
import android.widget.RatingBar.OnRatingBarChangeListener;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.TimePicker;

public class EdicionInmersion extends Activity  {
	private long id;
	private Inmersion inmersion;
	private Spinner spSite, spTraje, spBotella, spCorriente, spVisibilidad;
	private EditText comentario, lastre, presionIni, presionFin;
	private EditText tempAire, tempAgua,duracion,profMax;
	private String[] sitios;
	private TextView situacion;
	private String tipoTraje, tipoBotella, tipoCorriente, tipoVisibilidad;
	private String nombre;
	private ImageView imageView;
	private Uri uriFoto;
	final static int RESULTADO_EDITAR = 1;
	final static int RESULTADO_GALERIA = 2;
	final static int RESULTADO_FOTO = 3;

	// Widget GUI
	Button btnCalendar, btnTimePicker;
	EditText txtDate, txtTime;

	// Variable for storing current date and time
	private int mYear, mMonth, mDay, mHour, mMinute;

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.edicion_inmersion);

		Bundle extras = getIntent().getExtras();

		id = extras.getLong("id", -1); // id inmersin, -1 nueva
		inmersion = Inmersiones.elemento((int) id);
		spSite = (Spinner) findViewById(R.id.sp_sitio);

		sitios = CentrosBuceo.getPuntosInmersion();

		ArrayAdapter<String> adaptadorSitio = new ArrayAdapter<String>(this,
				android.R.layout.simple_spinner_item, sitios);
		adaptadorSitio
				.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spSite.setAdapter(adaptadorSitio);
		spSite.setSelection(getIndex(spSite, inmersion.getNombre()));
		// spSite.setSelection(0);
		spSite.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> parent,
					android.view.View v, int position, long id) {
	//			  ((TextView) parent.getChildAt(0)).setTextColor(Color.WHITE);
	//	       ((TextView) parent.getChildAt(0)).setTextSize(30);
				nombre = sitios[position];
				GeoPunto coord = CentrosBuceo.buscarLongLat(nombre);
				situacion.setText(coord.toString());

			}

			public void onNothingSelected(AdapterView<?> parent) {

			}
		});

		situacion = (TextView) findViewById(R.id.situacion);
		if (inmersion.getNombre() != null) {
			GeoPunto coord = CentrosBuceo.buscarLongLat(inmersion.getNombre());
			situacion.setText(coord.toString());
		} else
			situacion.setText("");


		txtDate = (EditText) findViewById(R.id.txtDate);
		txtDate.setText(DateFormat.getDateInstance().format(
				new Date(inmersion.getFecha())));
		txtTime = (EditText) findViewById(R.id.txtTime);
		txtTime.setText(DateFormat.getTimeInstance().format(
				new Date(inmersion.getFecha())));


		/*
		 * ImageView logo_tipo = (ImageView) findViewById(R.id.logo_tipo);
		 * logo_tipo.setImageResource(inmersion.getTipo().getRecurso());
		 */

		Resources res = this.getResources();
		final String tiposTraje[] = res.getStringArray(R.array.tipo_traje);
		spTraje = (Spinner) findViewById(R.id.sp_traje);

		ArrayAdapter<CharSequence> adaptador = ArrayAdapter.createFromResource(
				this, R.array.tipo_traje, android.R.layout.simple_spinner_item);
		adaptador
				.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spTraje.setAdapter(adaptador);
		spTraje.setSelection(getIndex(spTraje, inmersion.getTipoTraje()));

		spTraje.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> parent,
					android.view.View v, int position, long id) {

				tipoTraje = tiposTraje[position];

			}

			public void onNothingSelected(AdapterView<?> parent) {

			}
		});

		final String tiposBotella[] = res.getStringArray(R.array.tipo_botella);
		spBotella = (Spinner) findViewById(R.id.sp_botella);

		ArrayAdapter<CharSequence> adaptadorBotella = ArrayAdapter.createFromResource(
				this, R.array.tipo_botella, android.R.layout.simple_spinner_item);
		adaptadorBotella
				.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spBotella.setAdapter(adaptadorBotella);
		spBotella.setSelection(getIndex(spBotella, inmersion.getTipoBotella()));

		spBotella.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> parent,
					android.view.View v, int position, long id) {

				tipoBotella = tiposBotella[position];

			}

			public void onNothingSelected(AdapterView<?> parent) {

			}
		});
		
		final String tiposCorriente[] = res.getStringArray(R.array.tipo_corriente);
		spCorriente = (Spinner) findViewById(R.id.sp_corriente);

		ArrayAdapter<CharSequence> adaptadorCorriente = ArrayAdapter.createFromResource(
				this, R.array.tipo_corriente, android.R.layout.simple_spinner_item);
		adaptadorCorriente
				.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spCorriente.setAdapter(adaptadorCorriente);
		spCorriente.setSelection(getIndex(spCorriente, inmersion.getTipoCorriente()));

		spCorriente.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> parent,
					android.view.View v, int position, long id) {

				tipoCorriente = tiposCorriente[position];

			}

			public void onNothingSelected(AdapterView<?> parent) {

			}
		});
		
		final String tiposVisibilidad[] = res.getStringArray(R.array.tipo_visibilidad);
		spVisibilidad = (Spinner) findViewById(R.id.sp_visibilidad);

		ArrayAdapter<CharSequence> adaptadorVisibilidad = ArrayAdapter.createFromResource(
				this, R.array.tipo_visibilidad, android.R.layout.simple_spinner_item);
		adaptadorVisibilidad
				.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spVisibilidad.setAdapter(adaptadorVisibilidad);
		spVisibilidad.setSelection(getIndex(spVisibilidad, inmersion.getTipoVisibilidad()));

		spVisibilidad.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> parent,
					android.view.View v, int position, long id) {

				tipoVisibilidad = tiposVisibilidad[position];

			}

			public void onNothingSelected(AdapterView<?> parent) {

			}
		});
		
		lastre = (EditText) findViewById(R.id.lastre);
		lastre.setText( String.valueOf(inmersion.getLastre()));
		presionIni = (EditText) findViewById(R.id.presion_inicial);
		presionIni.setText(String.valueOf(inmersion.getPresionIni()));
		presionFin = (EditText) findViewById(R.id.presion_final);
		presionFin.setText(String.valueOf(inmersion.getPresionFinal()));
		tempAire = (EditText) findViewById(R.id.temp_aire);
		tempAire.setText(String.valueOf(inmersion.getTempAire()));
		tempAgua = (EditText) findViewById(R.id.temp_agua);
		tempAgua.setText(String.valueOf(inmersion.getTempAgua()));
		profMax = (EditText) findViewById(R.id.prof_max);
		profMax.setText(String.valueOf(inmersion.getProfMaxima()));
		duracion = (EditText) findViewById(R.id.tpo_buceo);
		duracion.setText(String.valueOf(inmersion.getDuracion()));
		
	    comentario = (EditText) findViewById(R.id.comentario);

		comentario.setText(inmersion.getComentario());

		RatingBar valoracion = (RatingBar) findViewById(R.id.valoracion);
		
		LayerDrawable stars = (LayerDrawable) valoracion.getProgressDrawable();
		stars.getDrawable(0).setColorFilter(Color.TRANSPARENT, PorterDuff.Mode.SRC_ATOP);
		stars.getDrawable(1).setColorFilter(Color.TRANSPARENT, PorterDuff.Mode.SRC_ATOP);
		stars.getDrawable(2).setColorFilter(Color.YELLOW, PorterDuff.Mode.SRC_ATOP);
		
		valoracion.setRating(inmersion.getValoracion());
		valoracion
				.setOnRatingBarChangeListener(new OnRatingBarChangeListener() {
					@Override
					public void onRatingChanged(RatingBar ratingBar,
							float valor, boolean fromUser) {
						inmersion.setValoracion(valor);
					}
				});
		imageView = (ImageView) findViewById(R.id.foto);
		ponerFoto(imageView, inmersion.getFoto());
		
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
    
		if (requestCode == RESULTADO_GALERIA
				&& resultCode == Activity.RESULT_OK) {
			inmersion.setFoto(data.getDataString());
			Inmersiones.actualizaInmersion((int) id, inmersion);
			ponerFoto(imageView, inmersion.getFoto());
		} else if (requestCode == RESULTADO_FOTO
				&& resultCode == Activity.RESULT_OK && inmersion != null
				&& uriFoto != null) {
			inmersion.setFoto(uriFoto.toString());
			Inmersiones.actualizaInmersion((int) id, inmersion);
			ponerFoto(imageView, inmersion.getFoto());
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.edicion_inmersion, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.accion_guardar:
			// String nombre = sitios[spSite.getSelectedItemPosition()];
			inmersion.setNombre(nombre);
			inmersion.setPosicion(CentrosBuceo.buscarLongLat(nombre));
			inmersion.setTipoTraje(tipoTraje);
			inmersion.setTipoBotella(tipoBotella);
	    	inmersion.setLastre(Integer.parseInt(lastre.getText().toString()));
			inmersion.setPresionIni(Integer.parseInt(presionIni.getText().toString()));
			inmersion.setPresionFinal(Integer.parseInt(presionFin.getText().toString()));
			inmersion.setTempAire(Integer.parseInt(tempAire.getText().toString()));
			inmersion.setTempAgua(Integer.parseInt(tempAgua.getText().toString()));
			inmersion.setProfMaxima(Integer.parseInt(profMax.getText().toString()));
			inmersion.setDuracion(Integer.parseInt(duracion.getText().toString()));
			inmersion.setTipoCorriente(tipoCorriente);
			inmersion.setTipoVisibilidad(tipoVisibilidad);
			inmersion.setComentario(comentario.getText().toString());
			long milliseconds = devuelveFecha(txtDate.getText().toString() + " " + txtTime.getText().toString()).getTime();
			inmersion.setFecha(milliseconds);
	
			Inmersiones.actualizaInmersion((int) id, inmersion);
			finish();
			return true;
		case R.id.accion_cancelar:
			 finish(); 
	          return true;
		default:
			return super.onOptionsItemSelected(item);
		}
	}

	private int getIndex(Spinner spinner, String myString) {

		int index = 0;

		for (int i = 0; i < spinner.getCount(); i++) {
			if (spinner.getItemAtPosition(i).equals(myString)) {
				index = i;
			}
		}
		return index;
	}


	
	@SuppressLint("SimpleDateFormat")
	public Date devuelveFecha(String fecha) {
		SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yyyy HH:mm");
		Date nuevaFecha = null;
		try {
			nuevaFecha = (Date) formatter.parse(fecha);

		} catch (ParseException e) {
			e.printStackTrace();
		}
		return nuevaFecha;

	}
	
	public void onClickHora(View v){
		// Process to get Current Time
		final Calendar c = Calendar.getInstance();
		mHour = c.get(Calendar.HOUR_OF_DAY);
		mMinute = c.get(Calendar.MINUTE);

		// Launch Time Picker Dialog
		TimePickerDialog tpd = new TimePickerDialog(this,
				new TimePickerDialog.OnTimeSetListener() {

					@Override
					public void onTimeSet(TimePicker view, int hourOfDay,
							int minute) {
						// Display Selected time in textbox
						txtTime.setText(hourOfDay + ":" + minute);
					}
				}, mHour, mMinute, false);
		tpd.show();
	}
	
	public void onClickFecha(View v){
		// Process to get Current Date
		final Calendar c = Calendar.getInstance();
		mYear = c.get(Calendar.YEAR);
		mMonth = c.get(Calendar.MONTH);
		mDay = c.get(Calendar.DAY_OF_MONTH);

		// Launch Date Picker Dialog
		DatePickerDialog dpd = new DatePickerDialog(this,
				new DatePickerDialog.OnDateSetListener() {

					@Override
					public void onDateSet(DatePicker view, int year,
							int monthOfYear, int dayOfMonth) {
						// Display Selected date in textbox
						txtDate.setText(dayOfMonth + "/"
								+ (monthOfYear + 1) + "/" + year);

					}
				}, mYear, mMonth, mDay);
		dpd.show();
	}
		
	
	// ************* tomarFoto *****************************************//

	public void tomarFoto(View view) {
		Intent intent = new Intent("android.media.action.IMAGE_CAPTURE");
		uriFoto = Uri.fromFile(new File(Environment
				.getExternalStorageDirectory()
				+ File.separator
				+ "img_"
				+ (System.currentTimeMillis() / 1000) + ".jpg"));
		intent.putExtra(MediaStore.EXTRA_OUTPUT, uriFoto);
		startActivityForResult(intent, RESULTADO_FOTO);
	}
	public void galeria(View view) {
		Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
		intent.addCategory(Intent.CATEGORY_OPENABLE);
		intent.setType("image/*");
		startActivityForResult(intent, RESULTADO_GALERIA);
	}

	public void eliminarFoto(View view) {
		inmersion.setFoto(null);
		ponerFoto(imageView, null);
		Inmersiones.actualizaInmersion((int) id, inmersion);
	}
	protected void ponerFoto(ImageView imageView, String uri) {
		if (uri != null) {
			imageView.setImageURI(Uri.parse(uri));
		} else {
			imageView.setImageBitmap(null);
		}
	}
}
