package com.proyecto.libroinmersiones;

import java.text.DecimalFormat;

public class Inmersion {
	private String nombre;
	private GeoPunto posicion;
	private String tipoTraje, tipoBotella;
	private int lastre, presionIni, presionFinal, profMaxima;
	private int tempAgua, tempAire, duracion;
	private String tipoCorriente, tipoVisibilidad;
	private String foto;
	private String comentario;
	private long fecha;
	private float valoracion;

	public Inmersion(String nombre, double longitud, double latitud,
			String tipoTraje, String tipoBotella, String comentario,
			int lastre, int presionIni, int presionFinal, int profMaxima,
			int tempAgua, int tempAire, int duracion, String tipoCorriente,
			String tipoVisibilidad, int valoracion) {

		fecha = System.currentTimeMillis();
		posicion = new GeoPunto(longitud, latitud);

		this.tipoTraje = tipoTraje;
		this.tipoBotella = tipoBotella;
		this.tipoCorriente = tipoCorriente;
		this.tipoVisibilidad = tipoVisibilidad;
		this.nombre = nombre;
		this.lastre = lastre;
		this.presionIni = presionIni;
		this.presionFinal = presionFinal;
		this.profMaxima = profMaxima;
		this.tempAgua = tempAgua;
		this.tempAire = tempAire;
		this.duracion = duracion;
		this.comentario = comentario;
		this.valoracion = valoracion;
	}

	public Inmersion() {
		fecha = System.currentTimeMillis();
		posicion = new GeoPunto(0, 0);
		tipoTraje = "5mm";
		tipoBotella = "12 litros";
		lastre = 5;
		presionIni = 200;
		presionFinal = 0;
		profMaxima = 20;
		tempAgua = 23;
		tempAire = 25;
		duracion = 50;
		tipoCorriente = "Floja";
		tipoVisibilidad = "Regular";
	}

	public GeoPunto getPosicion() {
		return posicion;
	}

	public void setPosicion(GeoPunto posicion) {
		this.posicion = posicion;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public String getFoto() {
		return foto;
	}

	public void setFoto(String foto) {
		this.foto = foto;
	}

	public String getComentario() {
		return comentario;
	}

	public void setComentario(String comentario) {
		this.comentario = comentario;
	}

	public long getFecha() {
		return fecha;
	}

	public void setFecha(long fecha) {
		this.fecha = fecha;
	}

	public float getValoracion() {
		return valoracion;
	}

	public void setValoracion(float valoracion) {
		this.valoracion = valoracion;
	}

	public String getTipoTraje() {
		return tipoTraje;
	}

	public void setTipoTraje(String tipoTraje) {
		this.tipoTraje = tipoTraje;
	}

	public void setTipoBotella(String tipoBotella) {
		this.tipoBotella = tipoBotella;
	}

	public String getTipoBotella() {
		return tipoBotella;
	}

	public void setTipoCorriente(String tipoCorriente) {
		this.tipoCorriente = tipoCorriente;
	}

	public String getTipoCorriente() {
		return tipoCorriente;
	}

	public void setTipoVisibilidad(String tipoVisibilidad) {
		this.tipoVisibilidad = tipoVisibilidad;
	}

	public String getTipoVisibilidad() {
		return tipoVisibilidad;
	}

	public int getLastre() {
		return lastre;
	}

	public void setLastre(int lastre) {
		this.lastre = lastre;
	}

	public int getPresionIni() {
		return presionIni;
	}

	public void setPresionIni(int presionIni) {
		this.presionIni = presionIni;
	}

	public int getPresionFinal() {
		return presionFinal;
	}

	public void setPresionFinal(int presionFinal) {
		this.presionFinal = presionFinal;
	}

	public int getProfMaxima() {
		return profMaxima;
	}

	public void setProfMaxima(int profMaxima) {
		this.profMaxima = profMaxima;
	}

	public int getTempAgua() {
		return tempAgua;
	}

	public void setTempAgua(int tempAgua) {
		this.tempAgua = tempAgua;
	}

	public int getTempAire() {
		return tempAire;
	}

	public void setTempAire(int tempAire) {
		this.tempAire = tempAire;
	}

	public int getDuracion() {
		return duracion;
	}

	public void setDuracion(int duracion) {
		this.duracion = duracion;
	}

	@Override
	public String toString() {
		return "Lugar [nombre=" + nombre + ", posicion=" + posicion
				+ ", tipo traje=" + tipoTraje + ", foto=" + foto
				+ ", telefono=" + ", comentario=" + comentario + ", fecha="
				+ fecha + ", valoracion=" + valoracion + "]";
	}

}
