package com.proyecto.libroinmersiones;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;

public class Inmersiones {

	final static String TAG = "MisInmersiones";
	protected static GeoPunto posicionActual = new GeoPunto(0, 0);
	private static InmersionesBD inmersionesBD;

	public static Inmersion elemento(int id) {
		Inmersion inmersion = null;
		SQLiteDatabase bd = inmersionesBD.getReadableDatabase();
		Cursor cursor = bd
				.rawQuery(
						"SELECT _id, nombre, longitud,  latitud,"
								+ " tipoTraje, foto, comentario,fecha, valoracion, tipoBotella,"
								+ " lastre, presionInicial, presionFinal, profMax,"
								+ " duracion, tempAire, tempAgua,"
								+ " visibilidad, corriente "
								+ " FROM inmersiones WHERE _id = " + id, null);
		if (cursor.moveToNext()) {
			inmersion = new Inmersion();
			inmersion.setNombre(cursor.getString(1));
			inmersion.setPosicion(new GeoPunto(cursor.getDouble(2), cursor
					.getDouble(3)));
			inmersion.setTipoTraje(cursor.getString(4));
			inmersion.setFoto(cursor.getString(5));
			inmersion.setComentario(cursor.getString(6));
			inmersion.setFecha(cursor.getLong(7));
			inmersion.setValoracion(cursor.getFloat(8));
			inmersion.setTipoBotella(cursor.getString(9));
			inmersion.setLastre(cursor.getInt(10));
			inmersion.setPresionIni(cursor.getInt(11));
			inmersion.setPresionFinal(cursor.getInt(12));
			inmersion.setProfMaxima(cursor.getInt(13));
			inmersion.setDuracion(cursor.getInt(14));
			inmersion.setTempAire(cursor.getInt(15));
			inmersion.setTempAgua(cursor.getInt(16));
			inmersion.setTipoVisibilidad(cursor.getString(17));
			inmersion.setTipoCorriente(cursor.getString(18));

		}
		cursor.close();
		bd.close();
		return inmersion;
	}

	public static int nuevo() {
		int id = -1;
		Inmersion inmersion = new Inmersion();
		SQLiteDatabase bd = inmersionesBD.getWritableDatabase();
		Log.d("Nuevo ----> ", inmersion.toString());
		bd.execSQL("INSERT INTO inmersiones (longitud, latitud, tipoTraje, tipoBotella, fecha, "
				+ " lastre, presionInicial, presionFinal, profMax,"
				+ " duracion, tempAire, tempAgua, visibilidad, corriente) "
				+ " VALUES ( "
				+ inmersion.getPosicion().getLongitud()
				+ ","
				+ inmersion.getPosicion().getLatitud()
				+ ", '" + inmersion.getTipoTraje()
				+ "', '"
				+ inmersion.getTipoBotella()
				+ "', "
				+ inmersion.getFecha()
				+ ", "
				+ inmersion.getLastre()
				+ ", "
				+ inmersion.getPresionIni()
				+ ", "
				+ inmersion.getPresionFinal() + ", " + inmersion.getProfMaxima() + ", " 
				+ inmersion.getDuracion() + ", " + inmersion.getTempAire() + ", "
				+ inmersion.getTempAgua() + ", '" + inmersion.getTipoVisibilidad() + "', '" 
				+ inmersion.getTipoCorriente() + "'"
				+ ")");
		Cursor c = bd.rawQuery("SELECT _id FROM inmersiones WHERE fecha = "
				+ inmersion.getFecha() + " AND nombre is null", null);
		Log.d("Nuevo-----> id: ", String.valueOf(id));
		if (c.moveToNext()) {
			id = c.getInt(0);
		}
		c.close();
		bd.close();
		return id;
	}

	public static void borrar(int id) {
		SQLiteDatabase bd = inmersionesBD.getWritableDatabase();
		bd.execSQL("DELETE FROM inmersiones WHERE _id = " + id);
		bd.close();
	}

	public static void inicializaBD(Context contexto) {
		inmersionesBD = new InmersionesBD(contexto);
	}

	public static Cursor listado() {
		SQLiteDatabase bd = inmersionesBD.getReadableDatabase();
		return bd
				.rawQuery(
						"SELECT * FROM inmersiones  ORDER BY fecha DESC LIMIT 50",
						null);
	}

	public static void actualizaInmersion(int id, Inmersion inmersion) {
		SQLiteDatabase bd = inmersionesBD.getWritableDatabase();
		bd.execSQL("UPDATE inmersiones SET nombre = '" + inmersion.getNombre()
				+ "', longitud = " + inmersion.getPosicion().getLongitud()
				+ " , latitud = " + inmersion.getPosicion().getLatitud()
				+ " , tipoTraje = '" + inmersion.getTipoTraje()
				+ "' , tipoBotella = '" + inmersion.getTipoBotella() + "', "
				+ " lastre = " + inmersion.getLastre() + ", "
				+ " presionInicial = " + inmersion.getPresionIni() + ", "
				+ " presionFinal = " + inmersion.getPresionFinal() + ", profMax = " + inmersion.getProfMaxima() + ", " 
				+ " duracion = " + inmersion.getDuracion() + ", tempAire = " + inmersion.getTempAire() + ", "
				+ " tempAgua = " + inmersion.getTempAgua() + ", visibilidad = '" + inmersion.getTipoVisibilidad() 
				+ "',  corriente = '" 
				+ inmersion.getTipoCorriente() + "'"			
				+ ", foto = '" + inmersion.getFoto() + "', comentario = '"
				+ inmersion.getComentario() + "', fecha = "
				+ inmersion.getFecha() + " , valoracion = "
				+ inmersion.getValoracion() + " WHERE _id = " + id);
		bd.close();
	}

	public static int buscarNombre(String nombre) {
		int id = -1;
		SQLiteDatabase bd = inmersionesBD.getReadableDatabase();
		Cursor c = bd.rawQuery("SELECT * FROM inmersiones WHERE nombre = '"
				+ nombre + "'", null);
		if (c.moveToNext()) {
			id = c.getInt(0);
		}
		c.close();
		bd.close();
		return id;
	}
}
