package com.proyecto.libroinmersiones;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import android.annotation.SuppressLint;
import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

public class InmersionesBD extends SQLiteOpenHelper {

	public InmersionesBD(Context contexto) {
		super(contexto, "inmersiones", null, 1);
	}

	@Override
	public void onCreate(SQLiteDatabase bd) {

		bd.execSQL("CREATE TABLE inmersiones ("
				+ "_id INTEGER PRIMARY KEY AUTOINCREMENT, " + "nombre TEXT, "
				+ "fecha LONG, " + "longitud REAL, " + "latitud REAL, "
				+ "tipoTraje TEXT, " + "tipoBotella TEXT, " + "lastre INTEGER, "
				+ "presionInicial INTEGER, presionFinal INTEGER, profMax INTEGER, "
				+ "duracion INTEGER, tempAire INTEGER, tempAgua INTEGER, "
				+ "visibilidad TEXT, corriente TEXT, "
				+ "foto TEXT, " + "comentario TEXT, "
				+ "valoracion REAL)");

		Date fecha;
		long milliseconds;
		fecha = devuelveFecha("27/08/2014 10:30");
		milliseconds = fecha.getTime();
		bd.execSQL("INSERT INTO inmersiones VALUES (null, " + "'El Litri', "
				+ milliseconds + ", -0.064,39.851, '5mm', '12l', "
				+ "5, 200, 50, 20, 50, 26, 23, 'Regular', 'Floja'"
				+ ", '', " // foto
				+ "'Poca visibilidad.' "
				+ ", 3.0)");
		fecha = devuelveFecha("28/08/2014 11:00");
		milliseconds = fecha.getTime();
		bd.execSQL("INSERT INTO inmersiones VALUES (null, " + "'El Ancla', "
				+ milliseconds + ", -0.061, 39.854, '5mm', '15l',"
				+ "5, 200, 50, 20, 50, 26, 23, 'Regular', 'Floja'"
				+ ", '', " // foto
				+ "'Corriente fuerte.' "
				+ ", 3.0)");
		fecha = devuelveFecha("20/09/2014 09:30");
		milliseconds = fecha.getTime();
		bd.execSQL("INSERT INTO inmersiones VALUES (null, " + "'El Ancla', "
				+ milliseconds + ", -0.061, 39.854, '5mm','12l', "
				+ "5, 200, 50, 20, 50, 26, 23, 'Regular', 'Floja'"
				+ ", '', " // foto
				+ "'Caballito de mar.' "
				+ ", 3.0)");
		
		bd.execSQL("CREATE TABLE centrosBuceo ("
				+ "_id INTEGER PRIMARY KEY AUTOINCREMENT, " + "nombre TEXT, "
				+ "direccion TEXT, " + "longitud REAL, " + "latitud REAL, "
				+ "tipo INTEGER, " + "foto TEXT, " + "telefono INTEGER, "
				+ "url TEXT, " + "comentario TEXT, " + "fecha LONG, "
				+ "valoracion REAL)");
		bd.execSQL("INSERT INTO centrosBuceo VALUES (null, "
				+ "'Les Illes Buceo', "
				+ "'Carrer Les Illes, 55 L Estartit (Girona)', 3.204585, 42.054968, "
				+ TipoCentroBuceo.HOTEL.ordinal() + ", '', 972751239, "
				+ "'http://www.hotellesilles.com/ES/11/hotel-les-illes-html', "
				+ "'Uno de los mejores para bucear en Medas.', "
				+ System.currentTimeMillis() + ", 3.0)");
		bd.execSQL("INSERT INTO centrosBuceo VALUES (null, "
				+ "'Rivemar Buceo', "
				+ "'Carretera de la Azoha, 151  La Azohia (Murcia)', -1.168541,37.556995, "
				+ TipoCentroBuceo.PUERTO.ordinal() + ", '', 968150063, "
				+ "'http://rivemar.com', " + "'El mejor en Cabo Palos.', "
				+ System.currentTimeMillis() + ", 3.0)");
		bd.execSQL("INSERT INTO centrosBuceo VALUES (null, " + "'El Litri', "
				+ "'Punto Inmersin (Burriana)', -0.064252,39.851882, "
				+ TipoCentroBuceo.SITIO.ordinal() + ", '', '', "
				+ "'http://cnburriana.com', " + "'Pecio. Profundidad 20 m', "
				+ System.currentTimeMillis() + ", 3.0)");
		bd.execSQL("INSERT INTO centrosBuceo VALUES (null, " + "'El Ancla', "
				+ "'Salida desde Nautico Burriana', -0.061505, 39.854468,"
				+ TipoCentroBuceo.SITIO.ordinal() + ", '', '', "
				+ "'http://cnburriana.com', " + "'Roca. Profundidad 18 m', "
				+ System.currentTimeMillis() + ", 3.0)");

	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
	}

	@SuppressLint("SimpleDateFormat")
	public Date devuelveFecha(String fecha) {
		SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yyyy HH:MM");
		Date nuevaFecha = null;
		try {
			nuevaFecha = (Date) formatter.parse(fecha);

		} catch (ParseException e) {
			e.printStackTrace();
		}
		return nuevaFecha;

	}
}
