package com.proyecto.libroinmersiones;

public enum TipoInmersion {
	SITIO ("Punto Inmersion", R.drawable.naturaleza),
	HOTEL ("Hotel", R.drawable.hotel),
	PUERTO ("Puerto", R.drawable.gasolinera),
	CURSO ("Puerto", R.drawable.educacion),
	    PLAYA ("Playa", R.drawable.deporte),
	    OTROS ("Otros", R.drawable.otros);

	private final String texto; 
	private final int recurso;  

	TipoInmersion(String texto, int recurso) {
	this.texto = texto;
	this.recurso = recurso;
	}

	public String getTexto() { return texto; }
	public int getRecurso() { return recurso; }   

	public static String[] getNombres() {
		   String[] resultado = new String[TipoInmersion.values().length];
		   for (TipoInmersion tipo : TipoInmersion.values()) {
		      resultado[tipo.ordinal()] = tipo.texto;
		   }
		   return resultado;
		}
}
